﻿using System;
using System.Collections.Generic;
using System.Collections.ObjectModel;

namespace MvvmLight5.Model
{
   public class CustomerCollection
   {
      private readonly ObservableCollection<Customer> _customers = new ObservableCollection<Customer>();
      public ObservableCollection<Customer> Customers
      {
         get { return _customers; }
      }

      public Customer GetCustomerByID( int id )
      {
         return _customers[ id ];
      }

      public CustomerCollection()
      {
         try
         {
            GenerateCustomers( 50 );
         }
         catch ( Exception e )
         {
            System.Windows.MessageBox.Show( "Exception: " + e.Message );
         }
      }

      public void GenerateCustomers( int howMany )
      {
         var firsts = new List<String>
                         {
                             "Abe",
                             "Alice",
                             "Barry",
                             "Basha",
                             "Charlie",
                             "Colette",
                             "David",
                             "Davida",
                             "Edgar",
                             "Elizabeth",
                             "Frank",
                             "Fran",
                             "George",
                             "Gary",
                             "Harry",
                             "Isaac",
                             "Jesse",
                             "Jessica",
                             "Kevin",
                             "Katrina",
                             "Larry",
                             "Linda",
                             "Mark",
                             "Melinda",
                             "Nick",
                             "Nancy",
                             "Oscar",
                             "Ophilia",
                             "Peter",
                             "Patricia",
                             "Quince",
                             "Quintina",
                             "Robert",
                             "Roberta",
                             "Shy",
                             "Sarah",
                             "Tom",
                             "Teri",
                             "Uberto",
                             "Uma",
                             "Victor",
                             "Victoria",
                             "Walter",
                             "Wendy",
                             "Xerxes",
                             "Xena",
                             "Yaakov",
                             "Yakira",
                             "Zach",
                             "Zahara"
                         };
         var lasts = new List<String>
                        {
                            "Anderson",
                            "Baker",
                            "Connors",
                            "Davidson",
                            "Edgecumbe",
                            "Franklin",
                            "Gregory",
                            "Hines",
                            "Isaacson",
                            "Johnson",
                            "Kennedy",
                            "Liberty",
                            "Mann",
                            "Nickerson",
                            "O'Dwyer",
                            "Patterson",
                            "Quimby",
                            "Richardson",
                            "Stevenson",
                            "Tino",
                            "Usher",
                            "Van Dam",
                            "Walker",
                            "Xenason",
                            "Yager",
                            "Zachery"
                        };
         var streets = new List<String>
                          {
                              "Ash",
                              "Beech",
                              "Cedar",
                              "Dogwood",
                              "Elm",
                              "Filbert",
                              "Ginkgo",
                              "Hawtorn",
                              "Ironwood",
                              "Juniper",
                              "Katsura",
                              "Lilac",
                              "Magnolia",
                              "Nectarine",
                              "Oak",
                              "Palm",
                              "Quince",
                              "Redwood",
                              "Sassafrass",
                              "Tupelo",
                              "Vibrunum",
                              "Walnut",
                              "Yellowwood",
                              "Zelkova"
                          };
         var cities = new List<String>
                         {
                             "Acton",
                             "Boston",
                             "Canton",
                             "Dell",
                             "Everstone",
                             "Flintwood",
                             "Gary",
                             "Houston",
                             "Imperial",
                             "Jackson",
                             "Kalamazoo",
                             "Levinworth",
                             "Macon",
                             "New York",
                             "Oak Hill",
                             "Paducah",
                             "Quinzy",
                             "Rochester",
                             "South Falls",
                             "Terra Haute",
                             "Union",
                             "Victoria",
                             "Waipio",
                             "Xenia",
                             "York",
                             "Zanesville"
                         };
         var isp = new List<String>
                      {
                          "ATT",
                          "Verizon",
                          "Hotmail",
                          "Gmail",
                          "Sprintnet",
                          "Yahoo"
                      };
         var states = new List<String>
                         {
                             "AL",
                             "AK",
                             "AS",
                             "AR",
                             "CA",
                             "CO",
                             "CT",
                             "DE",
                             "FL",
                             "GA",
                             "HI",
                             "ID",
                             "IL",
                             "IN",
                             "IA",
                             "KS",
                             "KY",
                             "LA",
                             "ME",
                             "MD",
                             "MA",
                             "MI",
                             "MN",
                             "MS",
                             "MO",
                             "MT",
                             "NE",
                             "NV",
                             "NH",
                             "NJ",
                             "NM",
                             "NY",
                             "NC",
                             "ND",
                             "OH",
                             "OK",
                             "PA",
                             "RI",
                             "SC",
                             "SD",
                             "TN",
                             "TX",
                             "UT",
                             "VA",
                             "WA",
                             "WI",
                             "WY"
                         };

         var random = new Random();
         for ( var i = 0; i < howMany; i++ )
         {
            var first = firsts[ random.Next( 0, firsts.Count ) ];
            var last = lasts[ random.Next( 0, lasts.Count ) ];
            var streetNumberInt = random.Next( 101, 999 );
            var streetNumber = streetNumberInt.ToString();
            var zipCode = random.Next( 10000, 99999 ).ToString();
            var phone = random.Next( 200, 999 ) + "-555-"
                            + random.Next( 2000, 9099 );
            var fax = random.Next( 200, 999 ) + "-555-"
                      + random.Next( 2000, 9099 );
            var email = first + "@"
                            + isp[ random.Next( 0, isp.Count ) ]
                            + ".com";

            _customers.Add(
                           new Customer(
                              i,
                               first,
                               last,
                               streetNumber + " "
                               +
                               streets[
                                       random.Next(
                                                   0, streets.Count - 1 )
                                   ]
                               + " Street",
                               cities[
                                      random.Next( 0, cities.Count - 1 )
                                   ],
                               states[
                                      random.Next( 0, states.Count - 1 )
                                   ],
                               zipCode,
                               phone,
                               fax,
                               email ) );
         }
      }
   }

   public class Customer
   {
      public int ID { get; set; }

      public string First { get; set; }

      public string Last { get; set; }

      public string Name { get { return First + " " + Last; } }

      public string Address { get; set; }

      public string City { get; set; }

      public string State { get; set; }

      public string Zip { get; set; }

      public string Phone { get; set; }

      public string Fax { get; set; }

      public string Email { get; set; }

      public Customer()
      { }

      public Customer(
         int id,
          string first,
          string last,
          string address,
          string city,
          string state,
          string zip,
          string phone,
          string fax,
          string email )
      {
         ID = id;
         First = first;
         Last = last;
         Address = address;
         City = city;
         State = state;
         Zip = zip;
         Phone = Phone;
         Fax = fax;
         Email = email;
      }
   }
}